package org.dromara.elevator.service.impl;

import org.dromara.common.core.exception.ServiceException;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.dromara.elevator.domain.EEmployInfo;
import org.springframework.stereotype.Service;
import org.dromara.elevator.domain.bo.EFactoryInfoBo;
import org.dromara.elevator.domain.vo.EFactoryInfoVo;
import org.dromara.elevator.domain.EFactoryInfo;
import org.dromara.elevator.mapper.EFactoryInfoMapper;
import org.dromara.elevator.service.IEFactoryInfoService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 生产厂家基础信息;Service业务层处理
 *
 * @author zy
 * @date 2024-07-29
 */
@RequiredArgsConstructor
@Service
public class EFactoryInfoServiceImpl implements IEFactoryInfoService {

    private final EFactoryInfoMapper baseMapper;

    /**
     * 查询生产厂家基础信息;
     *
     * @param id 主键
     * @return 生产厂家基础信息;
     */
    @Override
    public EFactoryInfoVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询生产厂家基础信息;列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 生产厂家基础信息;分页列表
     */
    @Override
    public TableDataInfo<EFactoryInfoVo> queryPageList(EFactoryInfoBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<EFactoryInfo> lqw = buildQueryWrapper(bo);
        Page<EFactoryInfoVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的生产厂家基础信息;列表
     *
     * @param bo 查询条件
     * @return 生产厂家基础信息;列表
     */
    @Override
    public List<EFactoryInfoVo> queryList(EFactoryInfoBo bo) {
        LambdaQueryWrapper<EFactoryInfo> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<EFactoryInfo> buildQueryWrapper(EFactoryInfoBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<EFactoryInfo> lqw = Wrappers.lambdaQuery();
        lqw.like(StringUtils.isNotBlank(bo.getName()), EFactoryInfo::getName, bo.getName());
        lqw.eq(StringUtils.isNotBlank(bo.getAddress()), EFactoryInfo::getAddress, bo.getAddress());
        lqw.eq(StringUtils.isNotBlank(bo.getContacts()), EFactoryInfo::getContacts, bo.getContacts());
        lqw.eq(StringUtils.isNotBlank(bo.getContactsPhone()), EFactoryInfo::getContactsPhone, bo.getContactsPhone());
        lqw.eq(bo.getState() != null, EFactoryInfo::getState, bo.getState());
        lqw.orderByDesc(EFactoryInfo::getCreateTime);
        return lqw;
    }

    /**
     * 新增生产厂家基础信息;
     *
     * @param bo 生产厂家基础信息;
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(EFactoryInfoBo bo) {
        EFactoryInfo add = MapstructUtils.convert(bo, EFactoryInfo.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改生产厂家基础信息;
     *
     * @param bo 生产厂家基础信息;
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(EFactoryInfoBo bo) {
        EFactoryInfo update = MapstructUtils.convert(bo, EFactoryInfo.class);
        validEntityBeforeUpdate(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(EFactoryInfo entity){
        //TODO 做一些数据校验,如唯一约束
        LambdaQueryWrapper<EFactoryInfo> code = Wrappers.lambdaQuery();
        code.eq(StringUtils.isNotBlank(entity.getCode()), EFactoryInfo::getCode, entity.getCode());
        List<EFactoryInfoVo> infoVoList = baseMapper.selectVoList(code);
        if (!infoVoList.isEmpty()) {
            throw new ServiceException("生产厂家编号已存在!");
        }
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeUpdate(EFactoryInfo entity){
        //TODO 做一些数据校验,如唯一约束
    }



    /**
     * 校验并批量删除生产厂家基础信息;信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }

    @Override
    public EFactoryInfoVo selectByCode(String code) {
        return baseMapper.selectVoOne(new LambdaQueryWrapper<EFactoryInfo>().eq(EFactoryInfo::getCode, code));
    }
}
